require.config({
  baseUrl: './js',
  paths: {
    //Models
    'patient-information': 'model/patient',
    'patient-sensitive-information': 'model/pii',
    'sed-model': 'model/sed',

    //Collections
    'patients': 'collection/patients',
    'sed-collection': 'collection/sedCollection',

    //Views
    'sed-view': 'view/content/patientDetailView/SEDView',
    'no-child-view' : 'view/content/myListView/noChildItemView',
    'session-ended-item-view': 'view/popup/sessionEndedItemView',
    'session-warning-item-view': 'view/popup/sessionWarningItemView',
    'delete-confirmation-item-view' : 'view/popup/deleteConfirmationView',
    'add-custom-call-item-view' : 'view/popup/addCustomCallItemView',
    'edit-notes-item-view' : 'view/popup/editNotesItemView',
    'timeline-details-item-view': 'view/content/patientDetailView/timelineDetailsItemView',
    'timeline-item-view': 'view/content/patientDetailView/timelineItemView',
    'timeline-composite-view': 'view/content/patientDetailView/timelineCompositeView',
    'profile-item-view': 'view/content/patientDetailView/profileItemView',
    'notes-item-view' : 'view/content/patientDetailView/notesItemView',
    'info-patient-detail-view' : 'view/content/patientDetailView/info-ItemView-PatientDetail',
    'my-patient-item-view': 'view/content/myListView/myPatientItemView',
    'patient-list-collection-view': 'view/content/myListView/patientListCollectionView',
    'filters-view': 'view/content/myListView/filtersView',
    'popup-handle-view': 'view/popup/popupHandleView',
    'patient-information-subview': 'view/patientInformationSubview',
    'patient-search-searchable': 'view/popup/addPatientView/searchablePatientView',
    'patient-search-form': 'view/popup/addPatientView/patientSearchFormView',
    'patient-information-popup': 'view/popup/patientSearchPopupView',
    'patient-search-list': 'view/popup/addPatientView/patientSearchListView',
    'edit-patient-view': 'view/content/editPatientView',
    'landing-view': 'view/content/homeView/landingView',
    'header-menu': 'view/header/headerMenu',
    'about-view': 'view/content/aboutView',
    'call-outlines-view': 'view/content/callOutlinesView',
    'add-patient-view': 'view/popup/addPatientView/addPatientView',
    'patient-detail-view': 'view/content/patientDetailView/patientDetailView',
    'my-list-view': 'view/content/myListView/myListView',
    'home-view': 'view/content/homeView/homeView',
    'layout-view': 'view/layoutView',
    'subfooter-view': 'view/content/homeView/subfooterView',
    'footer-view': 'view/footer/footerView',
    'header-view': 'view/header/headerView',
    'eula-view': 'view/body/eulaView',
    'splash-view': 'view/content/homeView/splashView',
    'logo-view': 'view/header/logoView',
    'header-title': 'view/header/headerTitleView',
    'exit-popup-view': 'view/popup/exitPopupView',
    'ajax-timeout-view': 'view/popup/ajaxTimeoutView',
    'ajax-disconnect-view': 'view/popup/ajaxDisconnectView',


    //Routers
    'router': 'router/router',

    //Controllers
    'popup-controller': 'controller/popupController',
    'date-controller': 'controller/dateController',
    'controller': 'controller/controller',
    'session-controller' : 'controller/sessionController',
    //Utilities
    'ha-resources': 'util/ha-resources',
    'bootstrap-datepicker': 'util/bootstrap-datepicker',
    'multi-region': 'util/multi-region',

    //Libraries
    'bootstrap': '../lib/sass-bootstrap/dist/js/bootstrap',
    'jquery': '../lib/jquery/dist/jquery',
    'underscore': '../lib/underscore/underscore',
    'backbone': '../lib/backbone/backbone',
    'backbone.wreqr': '../lib/backbone.wreqr/lib/backbone.wreqr',
    'backbone.babysitter': '../lib/backbone.babysitter/lib/backbone.babysitter',
    'marionette': '../lib/marionette/lib/core/amd/backbone.marionette',
    'json2': '../lib/json2/json2',

    //Plugins
    'text': '../lib/requirejs-text/text'
  },
  shim: {
    'app': {
      'deps': ['jquery', 'underscore', 'backbone', 'marionette']
    },
    'bootstrap': {
      'deps' : ['jquery']
    }
  }
});

require(['backbone', 'marionette', 'app', 'router', 'bootstrap', 'json2'], function (Backbone, Marionette, App, Router) {
  $.ajaxSetup({ cache: false, timeout: 30000 });
  App.addInitializer(function () {
    this.router = new Router();
    this.vent.trigger('route:startup');
  });
  App.start();
});
