define(function (require) {
  var App = require('app');

  return Backbone.Model.extend({

    defaults: {
      'id': null,
      'mccId': '',
      'patientId': '',
      'displayName': '',
      'nameFirst': '',
      'nameLast': '',
      'ssn': '',
      'dateOfBirth': -2209057200000,
      'gender': '',
      'address': '',
      'city': '',
      'state': '',
      'zip': '',
      'phone': '',
      'phoneType': 'Cell',
      'textEnabled': false,
      'email': '',
      'lmp': -2209057200000,
      'edd': -2209057200000,
      'eddSetBy': '',
      'mcc': '',
      'vaProvider': '',
      'vaFacility': '',
      'facilityId': '',
      'obProvider': '',
      'obContacts': [],
      'isPregnant': true,
      'remindersActive': true,
      'callDetails': [],
      'hasCustomCalls': false,
      'notes': '',
      'actualEndDate': -2209057200000,
      'pregOutcome': '',
      'endNotes': '',
      'archiveFlag': false
    },

    save: function () {
      //this is not allowed for this model
      //do nothing
    },
    patientFetch: function (patientId) {
      if (typeof patientId === 'undefined') {
        patientId = this.get('patientId');
      }
      var restURL = App.Resources.get('patient-detail').href + '?mccPatientId=' + patientId;



      this.fetch({
        url: restURL,
        dataType: 'json',
        reset: true,
        async: false
      }).fail(function (jqXHR) {
        if (jqXHR.status === 400) {
          App.vent.trigger('patient-details:error', $.parseJSON(jqXHR.responseText).message);
        }
      });
    },
    parse: function (response) {
      var patient = response;
      if (typeof response.link !== 'undefined') {
        this.Resources = App.Resources.instance(response.link);
        patient = {
          'displayName': response.displayName,
          'nameFirst': response.firstName,
          'nameLast': response.lastName,
          'ssn': response.ssn,
          'dateOfBirth': response.dateOfBirth,
          'gender': response.gender,
          'textEnabled': response.textMessagingAllowed
        };
      }
      if (typeof response.patientIdentifier !== 'undefined') {
        patient.patientId = response.patientIdentifier.uniqueId;
        return patient;
      }
      return patient;
    }

  });
});
