define(function (require) {
  var Controller = require('controller');
  var PopupController = require('popup-controller');
  var DateController = require('date-controller');
  var SessionController = require('session-controller');

  var App = require('app');

  var registerInternetDisconnectHandler = function () {
    var disconnected = false;
    $(document).ajaxSend(function () {
      if (!navigator.onLine) {
        App.vent.trigger('popup:hideAll');
        App.router.popups.showAjaxDisconnect();
        disconnected = true;
      }
    });
  };

  return Backbone.Marionette.AppRouter.extend({
    controller: new Controller(),
    popups: new PopupController(),
    dates: new DateController(),
    session: new SessionController(),
    appRoutes: {
      '' :             'showIndex',
      'home':          'showIndex',
      'help':          'showAbout',
      'about':         'showAbout',
      'edit-patient':  'showEditPatient',
      'my-patient':   'showMyPatient',
      'my-list/:sortOption':       'showMyList',
      'my-list':        'showMyList',
      'call-outlines/:id': 'showCallOutlines',
      'call-outlines' : 'showCallOutlines',
      'self-entered-data': 'showSED'
    },

    onRoute: function () {
      App.vent.trigger('popup:hideAll');
      if (localStorage.getItem('eulaAccepted') !== 'true') {
        this.controller.showEula();
        return;
      }
      registerInternetDisconnectHandler();
      App.activeCallID = null;
    }
  });
});
