define(function (require) {
  var App = require('app');
  var template = require('text!../html/landingView.html');

  return Backbone.Marionette.ItemView.extend({
    id: 'landing',
    tagName: 'div',
    className: '',
    template: _.template(template),

    events: {
      'click #add-patient-link': 'showPopup'
    },
    showPopup: function (e) {
      e.preventDefault();
      App.vent.trigger('popup:show', 'addPatient');
    },
    onShow: function () {
      $.ajax({
        url: App.Resources.getThisWeeksCallQueue(),
        global: false,
        dataType: 'json',
        success: this.updateCallQueueBtn,
        error: this.updateCallQueueBtn
      });
    },
    updateCallQueueBtn: function (jsonObjs, httpStatus, XHR) {
      var callCount = 0;
      var grammarHammer = 's';
      if (httpStatus === 'success') {
        callCount = jsonObjs.length;
      }

      if (callCount === 1) {
        grammarHammer = '';
      }

      var $spanTag = $('#call-queue-btn-txt');
      if ($spanTag.length > 0) {
        $spanTag.append('<br><span>(' + callCount +  ' call' + grammarHammer + ' this week)</span>');
      }

    }
  });
});
