define(function (require) {
  var App = require('app');
  var template = require('text!../html/myPatientItemView.html');

  return Backbone.Marionette.ItemView.extend({
    tagName: 'div',
    className: 'patient-item clearfix',
    template: _.template(template),
    attributes: {
      'tabindex': '0'
    },
    serializeData: function () {
      var eddFormatted = '';
      if (!App.router.dates.isDefaultDate(this.model.get('edd'))) {
        eddFormatted = App.router.dates.convertDate(new Date(this.model.get('edd')));
      }
      return {
        nameFirst    : this.model.get('nameFirst'),
        nameLast     : this.model.get('nameLast'),
        eddFormatted : eddFormatted,
        nextCall     : this.formatNextCall(this.model.getNextCall()),
        hasReminders : this.model.get('remindersActive'),
        linkToSED      : this.getLinkToSED(),
        hasCustomCalls : this.model.get('hasCustomCalls')
      };
    },
    formatNextCall: function (callDetail) {
      var nextCall = '';
      if (callDetail.id !== -1) {
        nextCall = App.router.dates.convertDate(new Date(callDetail.date));
      }
      return nextCall;
    },
    events: {
      'click' : 'showPatientDetail',
      'keypress' : 'showPatientDetail'
    },
    getLinkToSED : function () {
      return '#'; //TODO: find the link to SED when we finish VA moms
    },
    showPatientDetail: function (e) {
      e.preventDefault();
      if (e.type === 'keypress' && e.keyCode !== 13) { return; }
      App.router.navigate('my-patient');
      App.router.controller.showMyPatient(this.model);
    }
  });
});
