define(function (require) {
  var App = require('app');
  var template = require('text!../html/patientListCollectionView.html');
  var MyPatientItemView = require('my-patient-item-view');
  var NoChildItemViewTemplate = require('text!../html/noChildView.html');
  var Patients = require('patients');
  var Patient = require('patient-information');


  return Backbone.Marionette.CompositeView.extend({
    id: 'patient-list-collection-view',
    tagName: 'div',
    className: '',
    template: _.template(template),

    itemView: MyPatientItemView,
    itemViewContainer: '#scroll-box',

    initialize : function (args) {
      var Collection = Patients.extend({model: Patient});
      this.collection = new Collection();
      this.sortByOption = args.sortByOption || 0;
      var that = this;
      this.listenTo(App.vent, 'myList:shown', function () {
        switch (parseInt(that.sortByOption)) {
          case 0 :
            $('#call-queue-view').click();
            break;
          case 1 :
            $('#estimated-time-view').click();
            break;
          case 2 :
            $('#patient-name-view').click();
            break;
        }
      });
    },
    initialFetch : false,
    getTemplate : function () {
      if (this.initialFetch && this.collection && this.collection.length === 0) {
        return _.template(NoChildItemViewTemplate);
      } else {
        return this.template;
      }
    },
    onShow : function () {
      this.refresh();
    },
    events : {
    },
    collectionEvents : {
      'reset' : function () {this.initialFetch = true; this.render(); }
    },
    sortByPatientName : function (a, b) {
      var fullNameA = a.get('nameLast') + ' ' + a.get('nameFirst');
      var fullNameB = b.get('nameLast') + ' ' + b.get('nameFirst');

      if (fullNameA === fullNameB) {
        return 0;
      } else if (fullNameA > fullNameB) {
        return 1;
      } else {
        return -1;
      }
    },
    refresh: function () {
      this.collection.myListFetch();
    },
    sortByEDD : function (model) {
      return model.get('edd');
    },
    sortByCall : function (model) {
      return model.getNextCall().date;
    }

  });
});
