define(function (require) {
  var App = require('app');
  var template = require('text!../html/SEDView.html');

  return Backbone.Marionette.ItemView.extend({
    id: 'SEDView',
    tagName: 'div',
    className: 'SEDView col-lg',
    template: _.template(template),
    events: {

    },
    initialize: function (models) {
      this.model = models[0];
      this.model.on('change', this.render, this);
    },
    onShow: function () {
      $('.fieldname').each(function () {
        var fieldName = $(this).text();
        var fieldVal = $(this).next('.fieldval').text();
        $(this).next('.fieldval').attr('aria-label', fieldName + ' ' + fieldVal);
      });
      $('.fieldname').attr('aria-hidden', 'true');
    },
    templateHelpers: {

      formatDate: function (date) {

        var months = ['jan', 'feb', 'mar', 'apr', 'may', 'jun', 'jul', 'aug', 'sep', 'oct', 'nov', 'dec'];
        var monthsShort = ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'];
        var days = ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday', 'Sunday'];
        var daysShort = ['Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat'];
        var daysMin = ['Su', 'Mo', 'Tu', 'We', 'Th', 'Fr', 'Sa', 'Su'];
        var formatParts = /dd?|DD?|mm?|MM?|yy(?:yy)?/g;

        function parseFormat (format) {
          var separators = format.replace(formatParts, '\0').split('\0');
          var parts = format.match(formatParts);
          if (!separators || !separators.length || !parts || parts.length === 0) {
            throw new Error('Invalid date format.');
          }
          return {separators: separators, parts: parts};
        }
        function convertDate (date, format) {
          if (!(date instanceof Date)) { return ''; }
          if (!format) { format = 'mm/dd/yyyy'; }
          if (typeof format === 'string') {
            format = parseFormat(format);
          }
          var val = {
            d: date.getUTCDate(),
            D: daysShort[date.getUTCDay()],
            DD: days[date.getUTCDay()],
            m: date.getUTCMonth() + 1,
            M: monthsShort[date.getUTCMonth()],
            MM: months[date.getUTCMonth()],
            yy: date.getUTCFullYear().toString().substring(2),
            yyyy: date.getUTCFullYear()
          };
          val.dd = (val.d < 10 ? '0' : '') + val.d;
          val.mm = (val.m < 10 ? '0' : '') + val.m;
          date = [];
          var seps = $.extend([], format.separators);
          for (var i = 0, cnt = format.parts.length; i <= cnt; i++) {
            if (seps.length) {
              date.push(seps.shift());
            }
            date.push(val[format.parts[i]]);
          }
          return date.join('');
        }
        return (typeof date === 'string') ? '' : convertDate(new Date(date));
      }
    }
  });
});
