define(function (require) {
  var App = require('app');
  var template = require('text!../html/infoPatientDetail.html');
  var nextCall = '';
  var Patient = require('patient-information');
  var loading;
  var eloading;

  return Backbone.Marionette.ItemView.extend({
    id: 'pregnancy-report',
    tagName: 'div',
    className: '',
    template: _.template(template),

    events: {

    },
    initialize: function (options) {
      if (options.model) {
        this.model = options.model;
      } else if (window.sessionStorage.getItem('patientId')) {
        this.model = new Patient();
        this.model.patientFetch(window.sessionStorage.getItem('patientId'));
      }
      window.sessionStorage.setItem('patientId', this.model.get('patientId'));


      this.updateNextCall(this.model.getNextCall());
      this.listenTo(App.vent, 'updateNextCall', this.updateNextCall);
    },
    updateNextCall: function (callDetail) {
      nextCall = '';
      if (callDetail.id > 0) {
        nextCall = callDetail.date;
      }
      this.render();
    },
    onRender: function () {
      this.checkSED();
    },
    onShow: function () {

    },
    checkSED: function () {
      var authorityId = App.Resources.getAssigningAuthority();
      loading = $('.ajax-loading').parent();
      eloading = $('.ajax-loading').detach();
      var url = window.location.protocol + '//' + window.location.host + '/' + 'mcc-support-resources/rest/PatientResource/' + authorityId + '/patient-export-details?mccPatientId=' + window.sessionStorage.getItem('patientId');
      $.ajax({
        url: url,
        type: 'GET',
        dataType: 'json',
        success: function (data) {
          $('.sed-loading').hide();
          toggleSEDLink(data);
        },
        error: function () {
          $('.sed-loading').hide();
          toggleSEDLink('error');
        }
      });
      function toggleSEDLink (data) {
        if (data === 'error') {
          $('.sed-container').html('<p>Error Retrieving Data</p>');
        } else {
          var retrievedData = (typeof data === 'object' && !jQuery.isEmptyObject(data)) ? data : undefined;
          if (retrievedData === (undefined || 'undefined')) {
            $('.sed-container').html('<p>No Data</p>');
          }
          else if (retrievedData.profile !== undefined && retrievedData.profile.id !== undefined) {
            $('.sed-container').html('<a id="open-sed" href="#self-entered-data">Open</a>');
          } else {
            $('.sed-container').html('<p>No Data</p>');
          }
        }
        $('.sed-container').show();
      }
      loading.append(eloading);
    },
    templateHelpers: {
      eddFormatted: function () {
        var dateOut = new Date(this.edd);
        if (App.router.dates.isDefaultDate(dateOut) === false) {
          return App.router.dates.convertDate(dateOut);
        } else {
          return '';
        }
      },
      findNextCall: function () {
        if (nextCall !== '') {
          return App.router.dates.convertDate(new Date(nextCall));
        } else {
          return nextCall;
        }
      }
    }

  });
});
