define(function (require) {
  var App = require('app');
  var template = require('text!../html/notesItemView.html');
  var Patient = require('patient-information');

  return Backbone.Marionette.ItemView.extend({
    tagName: 'div',
    className: 'corners-rounded',
    id: 'notes-item-view',
    template: _.template(template),

    initialize: function (options) {
      if (options.model) {
        this.model = options.model;
      } else if (window.sessionStorage.getItem('patientId')) {
        this.model = new Patient();
        this.model.patientFetch(window.sessionStorage.getItem('patientId'));
      }
      window.sessionStorage.setItem('patientId', this.model.get('patientId'));
      this.listenTo(this.model, 'change', this.render);
    },
    events: {
      'click #edit-notes-btn': 'launchPopup'
    },
    launchPopup: function () {
      App.router.popups.showNotes(this.model);
    }
  });
});
