define(function (require) {
  var App = require('app');
  var template = require('text!../html/timelineItemView.html');
  var nextCallID = '';
  var activeCallID;
  return Backbone.Marionette.ItemView.extend({
    tagName: 'div',
    className: 'timeline-btn',
    template: _.template(template),
    serializeData: function () {
      var date = new Date(this.model.get('date'));
      activeCallID = App.activeCallID;
      return {
        monthName: App.router.dates.convertDate(date, 'M'),
        dayNum: date.getDate(),
        isNextCall: (this.model.get('id') === nextCallID),
        isActiveCall: (this.model.get('id') === activeCallID),
        isUpdate: this.isUpdate,
        completed: this.model.get('callsCompleted'),
        attempted: this.model.get('callsAttempted')
      };
    },
    events: {
      'click a': 'displayTimelineDetails'
    },
    initialize: function (options) {
      nextCallID = options.nextCall;
      App.activeCallID = App.activeCallID || nextCallID;
      this.isUpdate = false;
      this.listenTo(App.vent, 'timeline:toggle', this.makeActive);
      this.listenTo(App.vent, 'timeline:checkbox', this.updateCheckboxItem);
      this.listenTo(App.vent, 'timeline:nextCall', this.nextCallActive);
      this.listenTo(App.vent, 'timeline:activeCall', this.setActiveCall);
    },
    setActiveCall: function (id) {
      App.activeCallID = id;
    },
    makeActive: function (id) {
      App.activeCallID = id;
      if (id === this.model.get('id')) {
        this.$el.find('a').addClass('selected');
      } else {
        this.$el.find('a').removeClass('selected');
      }
    },
    nextCallActive: function (id) {
      nextCallID = id;
      this.render();
    },
    updateCheckboxItem: function (id, key, val) {
      if (id === this.model.get('id')) {
        this.model.set(key, val);
      }
    },
    displayTimelineDetails: function (e) {
      e.preventDefault();
      if (this.isUpdate) {
        this.isUpdate = false;
        this.render();
      }
      App.vent.trigger('timeline:toggle', this.model.get('id'));
      App.vent.trigger('timeline:details', this.model);
    }
  });
});
