define(['app', 'text!../html/headerMenu.html'], function (App, HeaderMenuTmpl) {
  'use strict';
  var HeaderMenuView = Backbone.Marionette.ItemView.extend({
    template: _.template(HeaderMenuTmpl),
    serializeData: function () {
      var data = {};

      if (App.Resources.isLoggedIn()) {
        data.menu = {
          '#home': 'Home',
          '#my-list/0': 'Call Queue',
          '#my-list': 'Maternity Patients',
          '#call-outlines': 'Call Outlines',
          '#about': 'About',
          '#': 'Exit'
        };
      } else {
        data.menu = {
            '#home': 'Home',
            '#call-outlines': 'Call Outlines',
            '#about': 'About'
          };
      }
      return data;
    },
    events: {
      'click .menu-toggle, .menu-overlay, .menu a': 'handleToggleMenu',
      'keydown .menu li:last a': function (e) {
        var tabOnly = !e.shiftKey && e.keyCode === 9;
        if (tabOnly) {
          e.preventDefault();
          this.$el.find('.menu-toggle').focus();
        }
      },
      'keydown .menu-toggle': function (e) {
        if (e.shiftKey && e.keyCode === 9) {
          e.preventDefault();
          this.$el.find('.menu a:last').focus();
        }
      },
      'keyup' : function (e) {
        if (e.keyCode === 27 && this.menuOpen) {
          this.handleToggleMenu();
        }
      }
    },
    menuOpen: false,
    handleToggleMenu: function () {
      this.$el.find('.menu').toggleClass('on');
      this.menuOpen = !this.menuOpen;
      if (this.menuOpen) {
        this.$el.find('.menu a:first').focus();
        App.vent.trigger('menu:open');
        App.views.header.$('.title').attr('aria-hidden', 'true');
        App.views.footer.$el.attr('aria-hidden', 'true');
      } else {
        this.$el.find('.menu-toggle').focus();
        App.vent.trigger('menu:close');
        App.views.header.$('.title').attr('aria-hidden', 'false');
        App.views.footer.$el.attr('aria-hidden', 'false');
      }
    }

  });
  return HeaderMenuView;
});
