define(['app', 'text!../html/header.html', 'header-menu'], function (App, HeaderTmpl, HeaderMenuView) {
  'use strict';
  var HeaderView = Backbone.Marionette.Layout.extend({
    id: 'header-layout',
    regions: {
      menu: '#menu-container',
      title: '#title',
      logo:  '#logo'
    },
    initialize: function (args) {
      this.logoView = new args.logo();
    },
    events: {
      'click .exit': 'launchExitPopup'
    },
    template: _.template(HeaderTmpl),
    serializeData: function () {
      return {
        appName: App.name
      };
    },
    onRender: function () {
      this.menu.show(new HeaderMenuView());
      this.showLogo();
    },
    showLogo: function () {
      this.logo.show(this.logoView);
    },
    hideLogo: function () {
      this.logo.close();
    },
    launchExitPopup: function (e) {
      e.preventDefault();
      App.vent.trigger('popup:show', 'exitPopup');
    }
  });
  return HeaderView;
});

