define(function (require) {
  var App = require('app');
  var template = require('text!../html/addPatientView.html');
  return Backbone.Marionette.Layout.extend({
    id: 'add-view',
    className: 'otherView',
    template: _.template(template),

    regions: {
      searchp: '#patient-search-box',
      results: '#patient-results-box'
    },
    events: {
      'submit #patient-search': 'submitSearch'
    },

    initialize: function (args) {
      App.views.searchpView = args.searchp;
      App.views.resultsView = args.results;
      App.views.add = this;
    },
    onRender : function () {
      App.views.add.searchp.show(App.views.searchpView);
      App.views.add.results.show(App.views.resultsView);
    },
    submitSearch: function (e) {
      e.preventDefault();
      App.vent.trigger('patients:fetch', e.target.elements.name.value);
    }

  });


});
