define(function (require) {
  var App = require('app');
  var template = require('text!../html/patientSearchFormView.html');

  return Backbone.Marionette.ItemView.extend({
    id: 'patient-search',
    tagName: 'div',
    className: '',
    template: _.template(template),

    events: {
      'keyup #patient-search-input': 'toggleClearIcon',
      'click .input-clear-icon': 'clearInput',
      'keypress .input-clear-icon': 'clearInput'
    },
    toggleClearIcon: function (e) {
      if (e.target.value.length > 0) {
        $('.input-clear-icon').show();
      } else {
        $('.input-clear-icon').hide();
      }
    },
    clearInput: function (e) {
      e.preventDefault();
      if (e.type === 'keypress' && e.keyCode !== 13) { return; }
      $('#patient-search-input').val('').focus();
      $('.input-clear-icon').hide();
    }

  });
});
