define(function (require) {
  var App = require('app');
  var PII = require('patient-sensitive-information');

  var template = require('text!../html/searchablePatientView.html');

  return Backbone.Marionette.ItemView.extend({
    tagName: 'div',
    className: 'patient',
    template: _.template(template),
    events: {
      'click': 'showPatientDialog'
    },
    initialize: function (options) {
      var exists = false;
      var patientId = this.model.get('patientIdentifier').uniqueId;
      if (options.patients) {
        for (var i = 0; i < options.patients.length; i++) {
          if (patientId === options.patients.at(i).get('patientId')) {
            exists = true;
            break;
          }
        }
      }
      this.model.set('exists', exists);
    },
    showPatientDialog: function (e) {
      e.preventDefault();
      var that = this;
      var patientID = that.model.get('patientIdentifier');
      var pid = patientID.uniqueId;
      var authorityId = patientID.assigningAuthority;
      var url = App.Resources.get('patient').href + '/' + authorityId + '/' + pid;
      var pii = new PII();

      pii.fetch({
        url: url,
        success: function () {
          pii.set('exists', that.model.get('exists'));

          App.router.popups.showPatientPopup(pii);
        }
      });
    }
  });
});
