define(function (require) {
  var App = require('app');
  var template = require('text!../html/deleteConfirmationView.html');

  return Backbone.Marionette.ItemView.extend({
    tagName: 'div',
    id: 'deleteConfirmationView',
    template: _.template(template),
    initialize: function (args) {
      this.model = args.model;
    },
    events: {
      'click #exit-btn': 'closePopup',
      'click #no-delete': 'closePopup',
      'click #yes-delete': 'deletePatient'
    },
    onShow: function () {

    },
    deletePatient: function () {
      var url = this.model.url() + '?mccPatientId=' + this.model.get('patientId');
      this.model.destroy({
        url: url,
        success: function () {
          App.router.navigate('my-list');
          App.router.controller.showMyList();
          App.vent.trigger('popup:hideAll');
        },
        wait: true,
        error: function () {
        }
      });
    },
    closePopup: function (e) {
      e.preventDefault();
      App.vent.trigger('popup:hideAll');
    }
  });
});
