define(function (require) {
  var App = require('app');
  var seshWarnTemplate = require('text!../html/sessionWarningItemView.html');
  var timerID = -1;

  return Backbone.Marionette.ItemView.extend({
    id: 'modalBox',
    tagName: 'div',
    template: _.template(seshWarnTemplate),

    initialize: function (args) {
      this.timeLeftInMinutes = Math.floor(args.timeLeft / 60000);
    },
    serializeData: function () {
      return {
        logout:    App.Resources.get('logout').href || '../MobileHealthPlatformWeb/cleanUpSession',
        timeLeft: this.timeLeftInMinutes
      };
    },
    decrementMinutesSpan: function self() {
      var minutes = 0;

      var $spanTag = $('#minutes-span');
      if ($spanTag.length > 0) {
        minutes = parseInt($spanTag.text());
        minutes--;
        $spanTag.text(minutes);
      }

      if (minutes > 0) {
        timerID = setTimeout(self, 60000);
      } else {
        return;
      }
    },
    events: {
      'click #logout-btn': 'onLogout',
      'click #continue-btn': 'onContinueSession'
    },
    onShow: function () {
      timerID = setTimeout(this.decrementMinutesSpan, 60000);
    },
    onContinueSession: function (e) {

      App.resetSessionTimer();
      clearTimeout(timerID);

    },
    onLogout: function (e) {
      clearTimeout(timerID);
      App.cleanUpSession();
    }
  });
});