require_relative 'Functions'
require "json"
require "selenium-webdriver"
gem "test-unit"
require "test/unit"

#gem 'ci_reporter'
#require 'ci/reporter/rake/test_unit_loader'

class Navigation < Test::Unit::TestCase
  def setup
    @driver = Selenium::WebDriver.for :firefox
    @accept_next_alert = true
    @driver.manage.timeouts.implicit_wait = 30
    @verification_errors = []

    set_variables()

  end

  def teardown
   # @driver.save_screenshot('./test/reports/ss_01Navigation.png')
    @driver.quit
    assert_equal [], @verification_errors
  end

  def test_01_navigation_menu
    puts "Running navigation menu tests"
    #MCC- 103: App Navigation
    # verify the options in the drop down menu when not logged in and when logged in
    accept_eula()
    # first verify the menu when not logged in: Home, About, Call Templates
    @driver.find_element(:class, "menu-toggle").click
    @driver.find_element(:link, "Home").click
    verify { assert(@driver.find_element(:id, "content").text.include?("Tools and Resources that Support"), "Unable to find the mcc support home page text") }
    @driver.find_element(:class, "menu-toggle").click
    @driver.find_element(:link,"Call Outlines").click
    verify { assert(@driver.find_element(:id, "content").text.include?("Conversation Outlines"), "Unable to find the call templates text") }
    @driver.find_element(:class, "menu-toggle").click
    @driver.find_element(:link, "About").click
    verify { assert(@driver.find_element(:id, "title").text.include?("About"), "Unable to find the about view text") }
    verify { assert(@driver.find_element(:class, "aboutContent").text.include?("This application provides the following resources"), "About text missing") }

    # now verify the menu when logged in: About, Home, Call Queue, Maternity Patients, Call Templates and exit
    login_to_mcc()
    # verify logo is present
    image_src = @driver.find_element(:class, "navbar-brand").attribute('src')
    verify { assert_equal(@app_url+"images/VAHealth-logo.png", image_src) }

    # click each of the menu options and verify the destination page
    @driver.find_element(:class, "menu-toggle").click
    @driver.find_element(:link, "About").click
    verify { assert_equal("About", @driver.find_element(:id, "title").text, "Unable to find the about view text") }
    verify { assert(@driver.find_element(:class, "aboutContent").text.include?("This application provides the following resources"), "About text missing") }
    @driver.find_element(:class, "menu-toggle").click
    @driver.find_element(:link, "Home").click
    verify { assert(@driver.find_element(:id, "content").text.include?("Tools and Resources that Support"), "Unable to find the mcc support home page text") }
    @driver.find_element(:class, "menu-toggle").click
    @driver.find_element(:link,"Call Queue").click
    verify { assert_equal("Maternity Patients", @driver.find_element(:id, "title").text(), "unable to find the maternity patient title") }
    @driver.find_element(:class,"menu-toggle").click
    @driver.find_element(:link, "Maternity Patients").click
    verify { assert_equal("Maternity Patients", @driver.find_element(:id, "title").text(), "unable to find the maternity patient title") }
    @driver.find_element(:class, "menu-toggle").click
    @driver.find_element(:link, "Call Outlines").click
    verify { assert(@driver.find_element(:id, "content").text.include?("Conversation Outlines"), "Unable to find the call templates text") }
    @driver.find_element(:class, "menu-toggle").click
    @driver.find_element(:link, "Exit").click
    @driver.find_element(:id, "logout").click
    verify { assert_equal(@launch_pad_url, @driver.current_url, "Exit did not return to the launch pad") }
    # logout() - this test should not have a logout since the last action is to logout and verify you are one the test page.
  end

end
