require_relative 'Functions'
require "json"
require "selenium-webdriver"
gem "test-unit"
require "test/unit"

#gem 'ci_reporter'
#require 'ci/reporter/rake/test_unit_loader'

class Login < Test::Unit::TestCase
  def setup
    @driver = Selenium::WebDriver.for :firefox
    @accept_next_alert = true
    @driver.manage.timeouts.implicit_wait = 30
    @verification_errors = []

    set_variables()

    # @login_status = "PROGRAMMER, ONE - TEST VAMC 3"
  end

  def teardown
    # @driver.save_screenshot('./test/reports/ss_01Navigation.png')
    @driver.quit
    assert_equal [], @verification_errors
  end

  def test_login_logout
    puts "Running login tests"
    # MCC-25 Login
    # verify a single login is used
    # login from launch pad
    @driver.get(@launch_pad_url)
    @driver.find_element(:id, "footer-logout-btn").click
    @driver.find_element(:id, "name-c").clear
    @driver.find_element(:id, "name-c").send_keys @username
    @driver.find_element(:id, "password").clear
    @driver.find_element(:id, "password").send_keys @pwd
    @driver.find_element(:id, "va-hospital").clear
    @driver.find_element(:id, "va-hospital").send_keys @va_facility
    sleep 1 # this should be a wait for the
    @driver.find_element(:link, @va_facility_fullname).click
    @driver.find_element(:id, "loginButton").click
    @driver.find_element(:id, "accept-btn").click
    accept_eula()
    verify { assert(@driver.page_source.include?("MCC Support"), "App name not present on home page.") }

    # also verify return to launch pad without logout or logout and return to launchpad
    #click the x to close and verify stays on home page
    @driver.find_element(:class, "menu-toggle").click
    @driver.find_element(:link, "Exit").click
    @driver.find_element(:css, "button.close").click
    verify { assert(@driver.page_source.include?("MCC Support"), "App name not present on home page.") }
    #use the exit menu option to return to the launch page
    @driver.find_element(:class, "menu-toggle").click
    @driver.find_element(:link, "Exit").click
    @driver.find_element(:id, "exit").click
    verify { assert(@launch_pad_url, @driver.current_url) }
    verify { assert(@driver.find_element(:id, "footer-username").text.include?@display_name) }
    #back to the app and use the logout
    @driver.get(@app_url)
    @driver.find_element(:class, "menu-toggle").click
    @driver.find_element(:link, "Exit").click
    @driver.find_element(:id, "logout").click
    verify { assert(@launch_pad_url, @driver.current_url) }
    verify { assert(@driver.find_element(:id, "footer-username").text.include?"Not logged in") }
  end

end

