require_relative 'Functions'
require "json"
require "selenium-webdriver"
gem "test-unit"
require "test/unit"

#gem 'ci_reporter'
#require "ci/reporter/rake/test_unit_loader"

class LaunchApp < Test::Unit::TestCase
  # Tests for MCC 104: Launch App
  def setup
    @driver = Selenium::WebDriver.for :firefox
    @accept_next_alert = true
    @driver.manage.timeouts.implicit_wait = 30
    @verification_errors = []

    set_variables()

  end

  def teardown
    # @driver.save_screenshot('./test/reports/ss_01Navigation.png')
    @driver.quit
    assert_equal [], @verification_errors
  end

  def test_launch_app
    puts "Running launch app tests"
    #MCC-133 Implement EULA decline redirect
    # acceptance criteria (MCC-104): declining EULA results in return to launchpad
    @driver.get(@app_url)
    @driver.navigate.refresh
    wait { @driver.find_element(:id, "decline-button") }
    @driver.find_element(:id, "decline-button").click
    verify { assert_equal(@launch_pad_url, @driver.current_url) }

    #MCC-130 Display EULA page, part of MCC-104 Launch App
    # verify the EULA is displayed when initially accessing the app
    @driver.get(@app_url)
    @driver.navigate.refresh
    sleep 1
    string_present = @driver.page_source.include? 'By agreeing to install '
    verify { assert(string_present, "Unable to find string on EULA page") }
    @driver.find_element(:id, "accept-button").click
    sleep 1
    string_present = @driver.page_source.include?('Tools and Resources that Support Maternity Care Coordination')
    verify { assert(string_present, "Unable to find text on home page when access app 2nd time") }

    # verify returning to the page does not force users to accept the EULA a 2nd time
    @driver.get(@app_url)
    @driver.navigate.refresh
    sleep 1
    string_present = @driver.page_source.include?('Tools and Resources that Support Maternity Care Coordination')
    verify { assert(string_present, "Unable to find text on home page when access app 2nd time") }

    # Launch pad includes MCC icon
    @driver.get(@launch_pad_url)
    sleep 2
    assert(@driver.page_source.include?("MCC Support"), "MCC Support app is not on the launchpad")
    @driver.find_element(:partial_link_text, "MCC Support").click
    wait { @driver.find_element(:id, "home-view") }
    string_present = @driver.page_source.include?('Tools and Resources that Support Maternity Care Coordination')
    assert(string_present, "Home page not displayed correctly after going to app via launchpad")
  end


end
