require_relative 'Functions'
require "json"
require "selenium-webdriver"
gem "test-unit"
require "test/unit"

#gem 'ci_reporter'
#require 'ci/reporter/rake/test_unit_loader'

class PatientSearch < Test::Unit::TestCase
  def setup
    @driver = Selenium::WebDriver.for :firefox
    @accept_next_alert = true
    @driver.manage.timeouts.implicit_wait = 30
    @verification_errors = []

    set_variables()

  end

  def teardown
    # @driver.save_screenshot('./test/reports/ss_01Navigation.png')
    @driver.quit
    assert_equal [], @verification_errors
  end

  def test_patient_search
    puts "Running patient search tests"
    accept_eula()
    login_to_mcc()





    remove_all_patients()
    wait { @driver.find_element(:id, "add-patient-link") }
    # MCC-64: user will see patient search field
    @driver.find_element(:id, "add-patient-link").click
    sleep 1
    # assert_equal("+Add a Patient to your List", @driver.find_element(:css, "p.focus-second").text)
    assert(@driver.find_element(:name, "name").displayed?, "Search is not displayed on the page")

    # MCC-194: User can search using the standard input parameters
    # search inputs (lastname, firstname, ssn, last initial and last 4 digits)
    # lastname
    search_query = "OUTPATIENT" #returns 2 female patients
    search_for_patient(search_query)
    assert((@driver.find_element(:css, "div.drop-down-result.patient-name").text.include?(search_query)), "Patient was not returned successfully: "  + search_query )
    # SSN
    search_query = "345-34-4567" # returns a single female patient
    search_for_patient(search_query)
    assert((@driver.find_element(:class, "drop-down-result").text.include?(search_query)), "Patient was not returned successfully: " + search_query  )
    # firstname

    # last initial first 4 digits
    search_query = "i4567" # returns multiple female patients
    search_for_patient(search_query)
    search_result = "Inpatient"
    assert((@driver.find_element(:css, "div.drop-down-result.patient-name").text.include?("INPATIENT")), "Patient was not returned successfully" )

    # MCC-231: Users can select a patient from the results and add to their list
    # search for a female patient and add to your list, verify the patient is returned
    search_query = "INPATIENT, GIRL"
    search_for_patient(search_query)
    assert_equal(search_query,(@driver.find_element(:css, "div.drop-down-result.patient-name").text), "Patient was not returned successfully" )

    @driver.find_element(:css, "div.drop-down-result.patient-name").click
    wait { @driver.find_element(:id, "add-mcc-list") }
    @driver.find_element(:id, "add-mcc-list").click
    wait { @driver.find_element(:id, "editPatient") }
    assert_equal("Edit Patient", @driver.find_element(:id, "title").text, "Not on the edit patient page.")

    # save and attempt to re-add the same patient. Verify the add to list is disabled and the current MCC is displayed.
    @driver.find_element(:id, "save-patient-details").click
    wait { @driver.find_element(:id, "patientDetail")}

    @driver.find_element(:class, "menu-toggle").click
    @driver.find_element(:link, "Home").click
    wait { @driver.find_element(:id, "home-view") }
    @driver.find_element(:id, "add-patient-link").click

    search_query = "INPATIENT, GIRL"
    search_for_patient(search_query)
    assert_equal(search_query,(@driver.find_element(:css, "div.drop-down-result.patient-name").text), "Patient was not returned successfully" )
    @driver.find_element(:css, "div.drop-down-result.patient-name").click
    wait { @driver.find_element(:id, "add-mcc-list") }
    sleep 1
    verify { assert_match /^[\s\S]*disable[\s\S]*$/, @driver.find_element(:id, "add-mcc-list").attribute("class") }
    verify { assert_equal @display_name, @driver.find_element(:id, "mccName").text }

    # remove_all_patients()
    @driver.get(@app_url)
    @driver.navigate.refresh()
    @driver.find_element(:class,"menu-toggle").click
    @driver.find_element(:link, "Maternity Patients").click
    sleep 2
    numResultsText = @driver.find_element(:id, "resultsCount").text
    numResults = numResultsText.to_i
    # assert_equal(10, numResultsText, "Testing")
    while (numResults > 0) do
      @driver.find_element(:xpath, "//div[@id='scroll-box']/div/span").click
      @driver.find_element(:id, "edit-patient").click
      @driver.find_element(:id, "delete-patient-details").click
      @driver.find_element(:id, "yes-delete").click
      wait { @driver.find_element(:id, "resultsCount") }
      sleep 2
      numResultsText = @driver.find_element(:id, "resultsCount").text
      numResults = numResultsText.to_i
    end
    @driver.get(@app_url)
    wait{ @driver.find_element(:id, "home-view")}
    logout()

  end

end

