require_relative 'Functions'
require "json"
require "selenium-webdriver"
gem "test-unit"
require "test/unit"

#gem 'ci_reporter'
#require 'ci/reporter/rake/test_unit_loader'

class PatientList < Test::Unit::TestCase
  def setup
    @driver = Selenium::WebDriver.for :firefox
    @accept_next_alert = true
    @driver.manage.timeouts.implicit_wait = 30
    @verification_errors = []

    set_variables()

  end

  def teardown
    # @driver.save_screenshot('./test/reports/ss_01Navigation.png')
    @driver.quit
    assert_equal [], @verification_errors
  end

  def test_view_patient_list
    puts "Running patient list tests"
    accept_eula()
    login_to_mcc()
    remove_all_patients()

    @driver.find_element(:xpath, "//div[@id='menu-container']/div/button").click
    @driver.find_element(:link, "Maternity Patients").click

    wait {@driver.find_element(:id, 'myList')}
    verify {assert @driver.find_element(:id, 'no-child-view').text.include?('There are currently no patients on your list.'), 'Text for no patients is missing from the list.'}

    @driver.find_element(:class, "menu-toggle").click
    @driver.find_element(:link, "Home").click

    wait { @driver.find_element(:id, "add-patient-link") }
    @driver.find_element(:id, "add-patient-link").click
    search_query = "OUTPATIENT, GIRL"
    search_for_patient(search_query)
    wait { @driver.find_element(:css, "div.drop-down-result.patient-name") }
    assert((@driver.find_element(:css, "div.drop-down-result.patient-name").text.include?(search_query)), "Patient was not returned successfully" )
    @driver.find_element(:css, "div.drop-down-result.patient-name").click
    !5.times{ break if (element_present?(:id, "add-mcc-list") rescue false); sleep 1 }
    @driver.find_element(:id, "add-mcc-list").click
    # add the last menstrual period date and save
    @driver.find_element(:id, "last-menstrual-period").clear
    @driver.find_element(:id, "last-menstrual-period").send_keys "03/01/2014"
    @driver.find_element(:id, "last-menstrual-period").send_keys :tab
    @driver.find_element(:id, "save-patient-details").click
    wait { @driver.find_element :id, "patientDetail"}

    # click the menu option to return to the maternity patient list
    @driver.find_element(:xpath, "//div[@id='menu-container']/div/button").click
    @driver.find_element(:link, "Maternity Patients").click

    wait { @driver.find_element(:id, "estimated-time-view") }
    @driver.find_element(:id, "estimated-time-view").click
    wait { @driver.find_element(:id, "call-queue-view") }
    @driver.find_element(:id, "call-queue-view").click
    remove_all_patients()
    logout()
  end

end

