require_relative 'Functions'
require "json"
require "selenium-webdriver"
gem "test-unit"
require "test/unit"

#gem 'ci_reporter'
#require 'ci/reporter/rake/test_unit_loader'

class PatientCallOutlines < Test::Unit::TestCase
  def setup
    @driver = Selenium::WebDriver.for :firefox
    @accept_next_alert = true
    @driver.manage.timeouts.implicit_wait = 30
    @verification_errors = []

    set_variables()

  end

  def teardown
    # @driver.save_screenshot('./test/reports/ss_01Navigation.png')
    @driver.quit
    assert_equal [], @verification_errors
  end

  def test_call_outlines
    puts "Running call outlines tests"
    accept_eula()
    # verify the destination of the call outline PDFs.
    # MCC-24
    @driver.get(@app_url)
    @driver.find_element(:class, "menu-toggle").click
    @driver.find_element(:link,"Call Outlines").click

    verify { assert_equal(@app_url + "content/MCCSupport.pdf#page=47", @driver.find_element(:partial_link_text, "Phone Call #1").attribute("href"), "URL for Call #1 is incorrect") }
    verify { assert_equal(@app_url + "content/MCCSupport.pdf#page=48", @driver.find_element(:partial_link_text, "Phone Call #2").attribute("href"), "URL for Call #2 is incorrect") }
    verify { assert_equal(@app_url + "content/MCCSupport.pdf#page=49", @driver.find_element(:partial_link_text, "Phone Call #3").attribute("href"), "URL for Call #3 is incorrect") }
    verify { assert_equal(@app_url + "content/MCCSupport.pdf#page=50", @driver.find_element(:partial_link_text, "Phone Call #4").attribute("href"), "URL for Call #4 is incorrect") }
    verify { assert_equal(@app_url + "content/MCCSupport.pdf#page=51", @driver.find_element(:partial_link_text, "Phone Call #5").attribute("href"), "URL for Call #5 is incorrect") }
    verify { assert_equal(@app_url + "content/MCCSupport.pdf#page=52", @driver.find_element(:partial_link_text, "Phone Call #6").attribute("href"), "URL for Call #6 is incorrect") }
    verify { assert_equal(@app_url + "content/MCCSupport.pdf#page=54", @driver.find_element(:partial_link_text, "Phone Call #7").attribute("href"), "URL for Call #7 is incorrect") }

    login_to_mcc()
    @driver.get(@app_url)
    @driver.find_element(:class, "menu-toggle").click
    @driver.find_element(:link,"Call Outlines").click
    verify { assert_equal(@app_url + "content/MCCSupport.pdf#page=47", @driver.find_element(:partial_link_text, "Phone Call #1").attribute("href"), "URL for Call #1 is incorrect") }
    verify { assert_equal(@app_url + "content/MCCSupport.pdf#page=48", @driver.find_element(:partial_link_text, "Phone Call #2").attribute("href"), "URL for Call #2 is incorrect") }
    verify { assert_equal(@app_url + "content/MCCSupport.pdf#page=49", @driver.find_element(:partial_link_text, "Phone Call #3").attribute("href"), "URL for Call #3 is incorrect") }
    verify { assert_equal(@app_url + "content/MCCSupport.pdf#page=50", @driver.find_element(:partial_link_text, "Phone Call #4").attribute("href"), "URL for Call #4 is incorrect") }
    verify { assert_equal(@app_url + "content/MCCSupport.pdf#page=51", @driver.find_element(:partial_link_text, "Phone Call #5").attribute("href"), "URL for Call #5 is incorrect") }
    verify { assert_equal(@app_url + "content/MCCSupport.pdf#page=52", @driver.find_element(:partial_link_text, "Phone Call #6").attribute("href"), "URL for Call #6 is incorrect") }
    verify { assert_equal(@app_url + "content/MCCSupport.pdf#page=54", @driver.find_element(:partial_link_text, "Phone Call #7").attribute("href"), "URL for Call #7 is incorrect") }
    logout()
  end



end

