require_relative 'Functions'
require "json"
require "selenium-webdriver"
gem "test-unit"
require "test/unit"

#gem 'ci_reporter'
#require 'ci/reporter/rake/test_unit_loader'

class CallReminders < Test::Unit::TestCase
  def setup
    @driver = Selenium::WebDriver.for :firefox
    @accept_next_alert = true
    @driver.manage.timeouts.implicit_wait = 30
    @verification_errors = []

    set_variables()

  end

  def teardown
    # @driver.save_screenshot('./test/reports/ss_01Navigation.png')
    @driver.quit
    assert_equal [], @verification_errors
  end

  def test_call_reminders
    puts "Running Call Reminder tests"
    accept_eula()
    login_to_mcc()
    remove_all_patients()

    @driver.find_element(:id, "add-patient-link").click
    search_for_patient("OUTPATIENT")
    @driver.find_element(:css, "div.drop-down-result.patient-name").click
    wait { @driver.find_element(:id, "add-mcc-list") }
    @driver.find_element(:id, "add-mcc-list").click
    wait{ @driver.find_element(:id, "editPatient") }
    # add data and save the patient
    # enter_text_field("last-menstrual-period", "03/01/2014")
    # enter_text_field("estimated-due-date", "12/06/2014")
    @driver.find_element(:id, "save-patient-details").click
    wait { @driver.find_element(:id, "patientDetail") }

    d = Date.today
    # add_customcall((d+9).strftime("%m/%d/%Y"))
    #date = (d+9).strftime("%m/%d/%Y")
    date = d.strftime("%m/%d/%Y ")
    date2 = d.strftime("%m/%d/%Y")

    verify { assert_equal date, @driver.find_element(:xpath, "//tr[@id='info-patient-detail']/td[3]").text, "First call listed is not today" }
    # go to the home page and check text for the calls this week
    @driver.find_element(:xpath, "//div[@id='menu-container']/div/button").click
    @driver.find_element(:link, "Home").click
    verify { assert_equal "(1 call this week)", @driver.find_element(:css, "#call-queue-btn-txt > span").text, "The home page reminders is incorrect with call reminders on"  }
    @driver.find_element(:css, "#call-queue-btn-txt > span").click
    verify { assert_equal date2, @driver.find_element(:css, "span.mypatient.col-xs-4 > span.bold").text, "The list is showing next call incorrectly with call reminders on" }

    # return to the patient details
    @driver.find_element(:xpath, "//div[@id='scroll-box']/div/span").click

    # turn call reminders off and verify the next call data is gone from the details and list pages.
    @driver.find_element(:id, "edit-patient").click
    @driver.find_element(:id, "call-reminders").click
    @driver.find_element(:id, "save-patient-details").click
    wait { @driver.find_element(:id, "patientDetail") }
    verify { assert_equal " ", @driver.find_element(:xpath, "//tr[@id='info-patient-detail']/td[3]").text, "Top line next call date was present with reminders off" }
    verify { assert !element_present?(:xpath, "//div[@id='timeline']/div/a/div"), "The timeline element on patient details was present with reminders off" }

    @driver.find_element(:xpath, "//div[@id='menu-container']/div/button").click
    @driver.find_element(:link, "Home").click
    verify { assert_equal "(0 calls this week)", @driver.find_element(:css, "#call-queue-btn-txt > span").text, "The home page reminders is incorrect with call reminders off" }
    @driver.find_element(:css, "#call-queue-btn-txt > span").click
    verify { assert !element_present?(:css, "span.mypatient.col-xs-4 > span.bold"), "Next call on the patient list showing with call reminders off" }

    remove_all_patients()
    logout()
  end



end

