require_relative 'Functions'
require "json"
require "selenium-webdriver"
gem "test-unit"
require "test/unit"

#gem 'ci_reporter'
#require 'ci/reporter/rake/test_unit_loader'

class PatientDatePicker < Test::Unit::TestCase
  def setup
    @driver = Selenium::WebDriver.for :firefox
    @accept_next_alert = true
    @driver.manage.timeouts.implicit_wait = 30
    @verification_errors = []

    set_variables()

  end

  def teardown
    # @driver.save_screenshot('./test/reports/ss_01Navigation.png')
    @driver.quit
    assert_equal [], @verification_errors
  end

  def test_date_picker
    puts "Running date picker tests"
    accept_eula()
    login_to_mcc()
    remove_all_patients()

    # add a patient and the add custom calls.
    search_query = "OUTPATIENT, GIRL"
    add_patient(search_query, true)
    @driver.find_element(:class, "menu-toggle").click
    @driver.find_element(:link, "Maternity Patients").click
    @driver.find_element(:xpath, "//div[@id='scroll-box']/div/span").click

    @driver.find_element(:id, "custom-call").click
    @driver.find_element(:id, "add-custom-call-title").click
    @driver.find_element(:id, "custom-call-date").clear
    @driver.find_element(:id, "custom-call-date").send_keys "03/00/2014"
    @driver.find_element(:id, "custom-call-date").send_keys :tab
    @driver.find_element(:id, "custom-call-data").send_keys "Test adding an invalid date"
    verify { assert_equal "Not a valid date.", @driver.find_element(:css, "span.date-validate.text-danger").text }
    verify { assert_match /^[\s\S]*disable[\s\S]*$/, @driver.find_element(:id, "save-custom-call").attribute("class") }
    @driver.find_element(:id, "custom-call-date").clear
    @driver.find_element(:id, "custom-call-date").send_keys "03/1/14"
    @driver.find_element(:id, "custom-call-date").send_keys :tab
    @driver.find_element(:id, "custom-call-data").send_keys :clear
    @driver.find_element(:id, "custom-call-data").send_keys "Test adding a valid date"
    @driver.find_element(:id, "save-custom-call").click

    remove_all_patients()
    logout()
  end



end

