require_relative 'Functions'
require "json"
require "selenium-webdriver"
gem "test-unit"
require "test/unit"

#gem 'ci_reporter'
#require 'ci/reporter/rake/test_unit_loader'

class PatientCallQueueUpdates < Test::Unit::TestCase
  def setup
    @driver = Selenium::WebDriver.for :firefox
    @accept_next_alert = true
    @driver.manage.timeouts.implicit_wait = 30
    @verification_errors = []
    set_variables()
  end

  def teardown
    # @driver.save_screenshot('./test/reports/ss_01Navigation.png')
    @driver.quit
    assert_equal [], @verification_errors
  end

  def test_call_queue_updates
    puts "Running call queue update tests"
    accept_eula()
    login_to_mcc()
    remove_all_patients()
    @driver.get(@app_url)
    add_patient("OUTPATIENT, GIRL", true)

    # go to patient details for outpatient, girl
    @driver.find_element(:xpath, "//div[@id='menu-container']/div/button").click
    @driver.find_element(:link, "Maternity Patients").click
    wait { @driver.find_element(:id, "patients-list") }
    @driver.find_element(:xpath, "//div[@id='scroll-box']/div/span").click
    wait { @driver.find_element(:id, "patientDetail") }
    # verify the dates for the calls that are autogenerated with Estimated Due Date = 12/6/2014
    verify { assert_equal "May\n24", @driver.find_element(:xpath, "//div[@id='timeline']/div/a").text, "Date for call was incorrect after initial add" }
    verify { assert_equal "Jul\n19", @driver.find_element(:xpath, "//div[@id='timeline']/div[2]/a").text, "Date for call was incorrect after initial add" }
    verify { assert_equal "Sep\n13", @driver.find_element(:xpath, "//div[@id='timeline']/div[4]/a").text, "Date for call was incorrect after initial add" }
    verify { assert_equal "Nov\n8", @driver.find_element(:xpath, "//div[@id='timeline']/div[5]/a").text, "Date for call was incorrect after initial add" }
    verify { assert_equal "Sep\n13", @driver.find_element(:xpath, "//div[@id='timeline']/div[4]/a").text, "Date for call was incorrect after initial add" }
    verify { assert_equal "Nov\n8", @driver.find_element(:xpath, "//div[@id='timeline']/div[5]/a/div").text, "Date for call was incorrect after initial add" }
    verify { assert_equal "Dec\n13", @driver.find_element(:xpath, "//div[@id='timeline']/div[6]/a").text, "Date for call was incorrect after initial add" }
    verify { assert_equal "Jan\n17", @driver.find_element(:xpath, "//div[@id='timeline']/div[7]/a").text, "Date for call was incorrect after initial add" }
    # click call complete for the first 3

    wait { @driver.find_element(:id, "edit-patient") }
    sleep 1
    @driver.find_element(:id, "edit-patient").click
    @driver.find_element(:id, "estimated-due-date").clear
    @driver.find_element(:id, "estimated-due-date").send_keys "12/16/2014"
    @driver.find_element(:id, "estimated-due-date").send_keys :tab
    sleep 1
    assert_equal("12/16/2014", @driver.find_element(:id, "estimated-due-date").attribute("value"), "Due date was not properly updated to 12/16" )
    @driver.find_element(:id, "save-patient-details").click
    wait { @driver.find_element(:id, "patientDetail") }

    verify { assert_equal "12/16/2014", @driver.find_element(:xpath, "//tr[@id='info-patient-detail']/td[2]").text, "Due date on patient details is not correct" }
    # and verify the call dates of the first 3 stayed, but the rest changed by 10 days
    verify { assert_equal "Jun\n3", @driver.find_element(:xpath, "//div[@id='timeline']/div/a").text, "Date for call was incorrect after EDD was updated" }
    verify { assert_equal "Jul\n29", @driver.find_element(:xpath, "//div[@id='timeline']/div[2]/a").text, "Date for call was incorrect after EDD was updated" }
    verify { assert_equal "Sep\n23", @driver.find_element(:xpath, "//div[@id='timeline']/div[4]/a").text, "Date for call was incorrect after EDD was updated" }
    verify { assert_equal "Nov\n18", @driver.find_element(:xpath, "//div[@id='timeline']/div[5]/a").text, "Date for call was incorrect after EDD was updated" }
    verify { assert_equal "Sep\n23", @driver.find_element(:xpath, "//div[@id='timeline']/div[4]/a").text, "Date for call was incorrect after EDD was updated" }
    verify { assert_equal "Nov\n18", @driver.find_element(:xpath, "//div[@id='timeline']/div[5]/a/div").text, "Date for call was incorrect after EDD was updated" }
    verify { assert_equal "Dec\n23", @driver.find_element(:xpath, "//div[@id='timeline']/div[6]/a").text, "Date for call was incorrect after EDD was updated" }
    verify { assert_equal "Jan\n27", @driver.find_element(:xpath, "//div[@id='timeline']/div[7]/a").text, "Date for call was incorrect after EDD was updated" }

    # finally add an actual date and verify the post-partum call date is updated
    @driver.find_element(:id, "edit-patient").click
    wait { @driver.find_element(:id, "actual-end-date") }
    @driver.find_element(:id, "actual-end-date").clear
    @driver.find_element(:id, "actual-end-date").send_keys "11/1/2014"
    sleep 1
    assert_equal("11/1/2014", @driver.find_element(:id, "actual-end-date").attribute("value"), "Actual date was not properly updated to 11/1" )

    @driver.find_element(:id, "actual-end-date").send_keys :tab
    @driver.find_element(:id, "save-patient-details").click
    wait { @driver.find_element(:id, "patientDetail") }
    verify { assert_equal "Dec\n23", @driver.find_element(:xpath, "//div[@id='timeline']/div[7]/a").text, "Date for last call was incorrect after actual date was added" }

    remove_all_patients()
    logout()
  end



end

