require_relative 'Functions'
require "json"
require "selenium-webdriver"
gem "test-unit"
require "test/unit"

#gem 'ci_reporter'
#require 'ci/reporter/rake/test_unit_loader'

class AddNotes < Test::Unit::TestCase
  def setup
    @driver = Selenium::WebDriver.for :firefox
    @accept_next_alert = true
    @driver.manage.timeouts.implicit_wait = 30
    @verification_errors = []

    set_variables()

  end

  def teardown
    # @driver.save_screenshot('./test/reports/ss_01Navigation.png')
    @driver.quit
    assert_equal [], @verification_errors
  end

  def test_add_notes
    puts "Running add notes tests"
    accept_eula()
    login_to_mcc()
    remove_all_patients()

    search_query = "OUTPATIENT, GIRL"
    add_patient(search_query, true)

    @driver.find_element(:class, "menu-toggle").click
    @driver.find_element(:link, "Maternity Patients").click
    @driver.find_element(:xpath, "//div[@id='scroll-box']/div/span").click
    sleep 1

    #STORY - MCC-33 Add Note
    #MCC-94 Comment/note box is visible
    assert_equal("Your notes go here!", @driver.find_element(:id, "notes-body-text").text, "The default notes comment is not viewable.")
    #MCC-95 Add or edit note
    @driver.find_element(:id, "edit-notes-btn").click
    wait { @driver.find_element(:id, "edit-notes-popup") }
    test_data = "TestData902234567890323456789042345678905234567890TestData902234567890323456789042345678905234567890"
    enter_text_field("notes-data",test_data)
    #MCC-96 Save note information
    @driver.find_element(:xpath, "//div[@id='edit-notes-popup']/button").click
    sleep 5
    assert_equal(test_data, @driver.find_element(:id, "notes-body-text").text, "The saved notes comment is not viewable.")

    remove_all_patients()
    logout()
  end



end

