require_relative 'Functions'
require "json"
require "selenium-webdriver"
gem "test-unit"
require "test/unit"

#gem 'ci_reporter'
#require 'ci/reporter/rake/test_unit_loader'


class AssignPatients < Test::Unit::TestCase
  def setup
    @driver = Selenium::WebDriver.for :firefox
    @accept_next_alert = true
    wait = Selenium::WebDriver::Wait.new(:timeout => 10) # seconds

    @driver.manage.timeouts.implicit_wait = 30
    @verification_errors = []

    set_variables()

  end

  def teardown
    # @driver.save_screenshot('./test/reports/ss_01Navigation.png')
    @driver.quit
    assert_equal [], @verification_errors
  end


  def test_assign_mcc_data
    puts "Running assign MCC data tests "
    # Testing MCC-261
    accept_eula()
    login_to_mcc()
    remove_all_patients()

    search_query='OUTPATIENT, GIRL'
    @driver.find_element(:id, "add-patient-link").click
    search_for_patient(search_query)
    sleep 1
    @driver.find_element(:css, 'div.drop-down-result.patient-name').click
    !5.times{ break if (element_present?(:id, 'add-mcc-list') rescue false); sleep 1 }
    @driver.find_element(:id, 'add-mcc-list').click
    sleep 5
    #basic data
    @driver.find_element(:id, 'last-menstrual-period').clear
    @driver.find_element(:id, 'last-menstrual-period').send_keys "03/01/2014"
    @driver.find_element(:id, 'last-menstrual-period').send_keys :tab

    # MCC-261 Assign patient to mccs
    #   ac mcc-508/544: mcc and facility fields default to the user / facility logged in and is not editable
    verify { assert_equal @display_name, @driver.find_element(:id, "mcc").attribute("value"), "The display name for the MCC is not correct on the edit page"}
    verify { assert_equal @va_facility, @driver.find_element(:id, "va-primary-facility").attribute("value"), "The VA Facility is not correct on the edit page" }

    @driver.find_element(:id, "save-patient-details").click
    wait {@driver.find_element(:id, 'patientDetail') }
    sleep 2
    # and verify the fields are save properly and displayed on the patient details page
    verify { assert_equal @display_name, @driver.find_element(:xpath, "//div[@id='profile-item-view']/div/div[2]/div[4]/div[2]/strong").text, 'MCC name not shown on patient detail page' }
    verify { assert_equal @va_facility, @driver.find_element(:xpath, "//div[@id='profile-item-view']/div/div[2]/div[6]/div[2]/strong").text, 'Facility name not shown on patient detail page' }

    #   ac MCC-509 These MCC values should reside in the Maternity List filter so that anyone at a site can view/filter patients based on the assigned MCC
    # Login as a different user, verify that user can see patients on another users list using the view filter.
    logout
    sleep 2
    login_to_mcc2
    # remove_all_patients
    # add a patient for this user
    add_patient('FORTY, INPATIENT', false)
    @driver.find_element(:xpath, "//div[@id='menu-container']/div/button").click
    @driver.find_element(:link, "Maternity Patients").click
    #switch to clinicclerk, two and verify outpatient girl is there
    Selenium::WebDriver::Support::Select.new(@driver.find_element(:id, "view-filter")).select_by(:text, @display_name)
    verify { assert @driver.find_element(:id, 'patients-list').text.include?('OUTPATIENT, GIRL'), "Outpatient, Girl was not in the patient list for mcc1"}
    Selenium::WebDriver::Support::Select.new(@driver.find_element(:id, "view-filter")).select_by(:text, "Show All")
    sleep 5
    remove_all_patients()
    logout()
  end


end
