require_relative 'Functions'
require "json"
require "selenium-webdriver"
gem "test-unit"
require "test/unit"

#gem 'ci_reporter'
#require 'ci/reporter/rake/test_unit_loader'


class RefreshPages < Test::Unit::TestCase
  def setup
    @driver = Selenium::WebDriver.for :firefox
    @accept_next_alert = true
    wait = Selenium::WebDriver::Wait.new(:timeout => 10) # seconds

    @driver.manage.timeouts.implicit_wait = 30
    @verification_errors = []

    set_variables()

  end

  def teardown
    # @driver.save_screenshot('./test/reports/ss_01Navigation.png')
    @driver.quit
    assert_equal [], @verification_errors
  end


  def test_refresh_pages
    puts 'Running refresh tests '
    # Testing MCC-552
    accept_eula()
    login_to_mcc()
    remove_all_patients()

    # start adding a patient, refresh the page before the first save (returns to the home page)
    search_query='OUTPATIENT, GIRL'
    @driver.find_element(:id, 'add-patient-link').click
    search_for_patient(search_query)
    sleep 1
    @driver.find_element(:css, 'div.drop-down-result.patient-name').click
    wait {@driver.find_element(:id, 'add-mcc-list') }
    @driver.find_element(:id, 'add-mcc-list').click
    wait { @driver.find_element(:id, 'editPatient') }
    wait { @driver.find_element(:class, 'name-line')}
    @driver.navigate.refresh()

    # Now save the patient and refresh on the patient detail page.
    wait { @driver.find_element(:id, 'home-view') }
    @driver.find_element(:id, 'add-patient-link').click
    search_for_patient(search_query)
    sleep 1
    @driver.find_element(:css, 'div.drop-down-result.patient-name').click
    wait {@driver.find_element(:id, 'add-mcc-list') }
    @driver.find_element(:id, 'add-mcc-list').click
    wait { @driver.find_element(:id, 'editPatient') }
    @driver.find_element(:id, 'last-menstrual-period').clear
    @driver.find_element(:id, 'last-menstrual-period').send_keys '03/01/2014'
    @driver.find_element(:id, 'last-menstrual-period').send_keys :tab

    @driver.find_element(:id, 'save-patient-details').click
    wait { @driver.find_element(:id, 'patientDetail')}
    wait { @driver.find_element(:class, 'name-line')}
    sleep 1
    @driver.navigate.refresh()
    wait { @driver.find_element(:id, 'patientDetail')}
    wait { @driver.find_element(:class, 'name-line')}

    # go to edit page and refresh the page
    @driver.find_element(:id, 'edit-patient').click
    wait { @driver.find_element(:id, 'editPatient') }
    wait { @driver.find_element(:class, 'name-line')}
    sleep 1
    @driver.navigate.refresh()
    wait { @driver.find_element(:id, 'editPatient') }
    wait { @driver.find_element(:class, 'name-line')}

    remove_all_patients()
    logout()
  end


end
