require_relative 'Functions'
require "json"
require "selenium-webdriver"
gem "test-unit"
require "test/unit"

#gem 'ci_reporter'
#require 'ci/reporter/rake/test_unit_loader'

class CustomCalls < Test::Unit::TestCase
  def setup
    @driver = Selenium::WebDriver.for :firefox
    @accept_next_alert = true
    @driver.manage.timeouts.implicit_wait = 30
    @verification_errors = []

    set_variables

    # @login_status = "PROGRAMMER, ONE - TEST VAMC 3"
  end

  def teardown
    # @driver.save_screenshot('./test/reports/ss_01Navigation.png')
    @driver.quit
    assert_equal [], @verification_errors
  end

  def test_custom_calls
    accept_eula
    login_to_mcc
    remove_all_patients
    add_patient('OUTPATIENT, GIRL',true)
    @driver.find_element(:xpath, "//div[@id='landing']/div/div[2]/a").click
    @driver.find_element(:xpath, "//div[@id='scroll-box']/div/span[4]").click
    wait {@driver.find_element(:id, 'custom-call')}

    d = Date.today
    # add_customcall((d+9).strftime("%m/%d/%Y"))
    date = (d+9).strftime("%m/%d/%Y")

    # add a custom call and then edit that call
    @driver.find_element(:id, "custom-call").click
    wait {@driver.find_element(:id, 'custom-call-date')}
    sleep 2
    @driver.find_element(:id, "custom-call-date").clear
    @driver.find_element(:id, "custom-call-date").send_keys date
    @driver.find_element(:id, "custom-call-data").clear
    @driver.find_element(:id, "custom-call-data").send_keys "This is a test of custom calls."
    @driver.find_element(:id, "save-custom-call").click
    sleep 5
    verify { assert_equal "This is a test of custom calls.", @driver.find_element(:id, "call-detail-reason").text, "Custom call text was incorrect" }
    @driver.find_element(:id, "call-detail-info-btn").click
    sleep 2
    wait {@driver.find_element(:id, 'custom-call-date')}
    @driver.find_element(:id, "custom-call-data").clear
    @driver.find_element(:id, "custom-call-data").send_keys "This is a test of custom calls. Edited field."
    @driver.find_element(:id, "save-custom-call").click
    sleep 5
    #MCC-350 Timeline is scalable to allow a user to see all calls (with scrolling if it exceeds the 7 that fit to a screen)
    @driver.find_element(:css, "b.glyphicon.glyphicon-chevron-right").click
    @driver.find_element(:css, "b.glyphicon.glyphicon-chevron-left").click
    remove_all_patients
    logout
  end
end
