
# The first few are generic functions that are useful across apps

def verify(&blk)
  yield
rescue Test::Unit::AssertionFailedError => ex
  @verification_errors << ex
end

def wait(&blk)
  wait = Selenium::WebDriver::Wait.new(:timeout => 30)
  wait.until {yield}
end

def close_alert_and_get_its_text(how, what)
  alert = @driver.switch_to().alert()
  #alert = ${receiver}.switch_to().alert()
  alert_text = alert.text
  if (@accept_next_alert) then
    alert.accept()
  else
    alert.dismiss()
  end
  alert_text
ensure
  @accept_next_alert = true
end

def alert_present?()
  @driver.find_element(how, what)
  #${receiver}.switch_to.alert
  true
rescue Selenium::WebDriver::Error::NoAlertPresentError
  false
end

def element_present?(how, what)
  @driver.find_element(how, what)
  #${receiver}.find_element(how, what)
  true
rescue Selenium::WebDriver::Error::NoSuchElementError
  false
end

# and these are specific for MCC
# with the possible exceptions of set_variables accept_eula and login
def set_variables
  # puts "In set variables"
  # @base_url = "https://hastaffdev.agilexhealth.com:8443/"
  @base_url = "https://hastafftest.agilexhealth.com/"
  #@base_url = "http://localhost:8080/"
  @app_url = @base_url+"mcc-support/"
  @launch_pad_url = @base_url+"launchpad/"

  # # provider-prod - main user
  # @username="clerk3434"
  # @pwd = "clerk4343$"
  # @va_facility = "TEST VAMC 3"
  # @va_facility_fullname = "TEST VAMC 3 - CHANTILLY - VA"
  # @display_name = "CLINICCLERK, TWENTY"


  # provider-prod - main user
  @username="clerk0987"
  @pwd = "clerk7890$"
  @va_facility = "TEST VAMC 3"
  @va_facility_fullname = "TEST VAMC 3 - CHANTILLY - VA"
  @display_name = "CLINICCLERK, TWO"

  # # provider-prod - main user
  # @username="cprs1234"
  # @pwd = "cprs4321$"
  # @va_facility = "TEST VAMC 3"
  # @va_facility_fullname = "TEST VAMC 3 - CHANTILLY - VA"
  # @display_name = "PROGRAMMER, ONE"

  # provider-prod - 2nd user
  @username2="clerk6767"
  @pwd2 = "clerk7676$"
  @va_facility2 = "TEST VAMC 3"
  @va_facility_fullname2 = "TEST VAMC 3 - CHANTILLY - VA"
  @display_name2 = "CLINICCLERK, THREE"


end


def accept_eula
  # @driver.get(@launch_pad_url)
  @driver.get(@app_url)
  @driver.navigate.refresh()
  wait { @driver.find_element(:id, "accept-button") }
  sleep 1
  @driver.find_element(:id, "accept-button").click
  wait { @driver.find_element(:id, "home-view") }
end

def logout
  @driver.get(@app_url)
  @driver.find_element(:xpath, "//div[@id='menu-container']/div/button").click
  if ( (element_present?(:link, "Exit")) )
    @driver.find_element(:link, "Exit").click
    @driver.find_element(:id, "logout").click
  end

end

def login_to_mcc
  @driver.get(@app_url)
  @driver.navigate.refresh()
  @driver.find_element(:id, "login-button").click
  @driver.find_element(:id, "name-c").clear
  @driver.find_element(:id, "name-c").send_keys @username
  @driver.find_element(:id, "password").clear
  @driver.find_element(:id, "password").send_keys @pwd
  @driver.find_element(:id, "va-hospital").clear
  @driver.find_element(:id, "va-hospital").send_keys 'TEST'
  wait { @driver.find_element(:link, @va_facility_fullname) }
  # sleep 1
  @driver.find_element(:link, @va_facility_fullname).click
  wait{ @driver.find_element(:id, "va-hospital").attribute("value") == "TEST VAMC 3" }
  # sleep 5
  @driver.find_element(:id, "loginButton").click
  wait { @driver.find_element(:id, "home-view") }
end

def login_to_mcc2
  @driver.get(@app_url)
  @driver.navigate.refresh()
  @driver.find_element(:id, "login-button").click
  @driver.find_element(:id, "name-c").clear
  @driver.find_element(:id, "name-c").send_keys @username2
  @driver.find_element(:id, "password").clear
  @driver.find_element(:id, "password").send_keys @pwd2
  @driver.find_element(:id, "va-hospital").clear
  @driver.find_element(:id, "va-hospital").send_keys 'TEST'
  wait { @driver.find_element(:link, @va_facility_fullname) }
  # sleep 1
  @driver.find_element(:link, @va_facility_fullname2).click
  wait{ @driver.find_element(:id, "va-hospital").attribute("value") == "TEST VAMC 3" }
  # sleep 5
  @driver.find_element(:id, "loginButton").click
  wait { @driver.find_element(:id, "home-view") }
  sleep 5
end


def search_for_patient(search_query)
  # first clear out the search results
  @driver.find_element(:name, "name").clear
  @driver.find_element(:name, "name").send_keys :enter
  sleep 5 # sleep 5 seconds to confirm the results are cleared out
  # now search for the search_query and wait for results
  @driver.find_element(:name, "name").clear
  @driver.find_element(:name, "name").send_keys search_query
  @driver.find_element(:name, "name").send_keys :enter
  sleep 5
end

def add_patient(patient_name, add_details)
  @driver.find_element(:class, "menu-toggle").click
  @driver.find_element(:link, "Home").click
  wait { @driver.find_element(:id, "add-patient-link") }
  @driver.find_element(:id, "add-patient-link").click
  wait { @driver.find_element(:name, "name") }
  search_for_patient(patient_name)
  @driver.find_element(:css, "div.drop-down-result.patient-name").click
  wait { @driver.find_element(:id, "add-mcc-list") }
  @driver.find_element(:id, "add-mcc-list").click
  sleep 5
  wait { @driver.find_element(:id, "last-menstrual-period") }
  if (add_details)
    enter_text_field("last-menstrual-period", "03/01/2014")
    enter_text_field("estimated-due-date", "12/06/2014")
    # enter_text_field("mcc", "MCC Name")
    enter_text_field("va-primary-care", "Va Doctor")
    # enter_text_field("va-primary-facility", "Va Facility")
    enter_text_field("vet-phone", "555-555-5555")
    enter_text_field("vet-email", "mccname@va.gov")
    enter_text_field("vet-address-street", "1234 Street")
    enter_text_field("vet-address-city", "City")
    enter_text_field("vet-address-state", "State")
    enter_text_field("vet-address-zip", "12345")
    enter_text_field("ob-provider", "OB Name")
    @driver.find_element(:name, "contactInfo").clear
    @driver.find_element(:name, "contactInfo").send_keys "555-555-5555"
    @driver.find_element(:name, "contactInfo").send_keys :tab
  end
  @driver.find_element(:id, "save-patient-details").click
  wait { @driver.find_element(:id, "patientDetail")}
  @driver.find_element(:class, "menu-toggle").click
  @driver.find_element(:link, "Home").click
  wait { @driver.find_element(:id, "home-view") }
end

def enter_text_field(field_name, text_to_enter)
  @driver.find_element(:id, field_name).clear
  @driver.find_element(:id, field_name).send_keys text_to_enter
  sleep 1
  @driver.find_element(:id, field_name).send_keys :tab
end

def check_max_field_length(field_to_check, expected_text, long_text)
  @driver.find_element(:id, field_to_check).clear
  @driver.find_element(:id, field_to_check).send_keys long_text
  @driver.find_element(:id, field_to_check).send_keys :tab
  verify { assert_equal(expected_text, @driver.find_element(:id, field_to_check).attribute("value")) }
end



def remove_patient(patient_name)
  sleep 2
  @driver.find_element(:class, "menu-toggle").click
  @driver.find_element(:link, "Maternity Patients").click
  xpath = "//span[text() = '" + patient_name + "']"
  @driver.find_element(:xpath, xpath).click
  @driver.find_element(:id, "edit-patient").click
  @driver.find_element(:id, "delete-patient-details").click
  @driver.find_element(:id, "yes-delete").click
  wait { @driver.find_element(:class, "menu-toggle") }
  @driver.find_element(:class, "menu-toggle").click
  @driver.find_element(:link, "Home").click
end

def remove_all_patients
  # @driver.get(@app_url)
  # @driver.navigate.refresh()
  @driver.find_element(:class,"menu-toggle").click
  @driver.find_element(:link, "Maternity Patients").click
  sleep 2
  Selenium::WebDriver::Support::Select.new(@driver.find_element(:id, "view-filter")).select_by(:text, "Show All")
  sleep 2
  numResultsText = @driver.find_element(:id, "resultsCount").text
  numResults = numResultsText.to_i
  # assert_equal(10, numResultsText, "Testing")
  while (numResults > 0) do
    @driver.find_element(:xpath, "//div[@id='scroll-box']/div/span").click
    @driver.find_element(:id, "edit-patient").click
    @driver.find_element(:id, "delete-patient-details").click
    @driver.find_element(:id, "yes-delete").click
    wait { @driver.find_element(:id, "resultsCount") }
    sleep 2
    Selenium::WebDriver::Support::Select.new(@driver.find_element(:id, "view-filter")).select_by(:text, "Show All")
    sleep 2
    numResultsText = @driver.find_element(:id, "resultsCount").text
    numResults = numResultsText.to_i
  end
  @driver.get(@app_url)
  wait{ @driver.find_element(:id, "home-view")}
end

def goto_timeline(patient_name)
  @driver.find_element(:class, "menu-toggle").click
  @driver.find_element(:link, "Maternity Patients").click
  xpath = "//span[text() = '" + patient_name + "']"
  @driver.find_element(:xpath, xpath).click
  @driver.find_element(:id, "edit-patient").click
end

def goto_addnote(patient_name)
  goto_timeline(patient_name)
  @driver.find_element(:id, "edit-notes").click
end

def add_customcall (date)
  #assume that you are on patient detail page
  @driver.find_element(:id, "custom-call").click
  enter_text_field("custom-call-date", date)
  @driver.find_element(:id, "custom-call-data").clear
  @driver.find_element(:id, "custom-call-data").send_keys "Add Custom Call"
  @driver.find_element(:id, "save-custom-call").click
  sleep 2
end

def check_field(field_to_check, expected_text)
  #@driver.find_element(:id, field_to_check).clear
  #@driver.find_element(:id, field_to_check).send_keys long_text
  #@driver.find_element(:id, field_to_check).send_keys :tab
  assert_equal(expected_text, @driver.find_element(:id, field_to_check).attribute("value"))
end
